org.bdgenomics.adam.rdd.read

# AlignmentRecordRDD

###
Related Docs: object AlignmentRecordRDD | package read

#### sealed abstract class AlignmentRecordRDD extends AvroRecordGroupGenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD]

Linear Supertypes
AvroRecordGroupGenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD], GenomicDatasetWithLineage[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD], AvroGenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD], GenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD], Logging, AnyRef, Any
Known Subclasses
DatasetBoundAlignmentRecordRDD, ParquetUnboundAlignmentRecordRDD, RDDBoundAlignmentRecordRDD
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. AlignmentRecordRDD
2. AvroRecordGroupGenomicDataset
3. GenomicDatasetWithLineage
4. AvroGenomicDataset
5. GenomicDataset
6. Logging
7. AnyRef
8. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract val dataset: Dataset[AlignmentRecord]

   These data as a Spark SQL Dataset.

   These data as a Spark SQL Dataset.

   Definition Classes
     GenomicDataset

2. #### abstract val optPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]]

   Attributes
     protected
   Definition Classes
     GenomicDataset

3. #### abstract val processingSteps: Seq[ProcessingStep]

   The processing steps that have been applied to this GenomicDataset.

   The processing steps that have been applied to this GenomicDataset.

   Definition Classes
     GenomicDatasetWithLineage

4. #### abstract val rdd: RDD[AlignmentRecord]

   The RDD of genomic data that we are wrapping.

   The RDD of genomic data that we are wrapping.

   Definition Classes
     GenomicDataset

5. #### abstract val recordGroups: RecordGroupDictionary

   A dictionary describing the record groups attached to this GenomicDataset.

   A dictionary describing the record groups attached to this GenomicDataset.

   Definition Classes
     AvroRecordGroupGenomicDataset

6. #### abstract def replaceProcessingSteps(newProcessingSteps: Seq[ProcessingStep]): AlignmentRecordRDD

   Replaces the processing steps attached to this RDD.

   Replaces the processing steps attached to this RDD.

   newProcessingSteps

     The new processing steps to attach to this RDD.

   returns

     Returns a new GenomicDataset with new processing lineage attached.

   Definition Classes
     GenomicDatasetWithLineage

7. #### abstract def replaceRecordGroups(newRecordGroups: RecordGroupDictionary): AlignmentRecordRDD

   Replaces the record groups attached to this RDD.

   Replaces the record groups attached to this RDD.

   newRecordGroups

     The new record group dictionary to attach.

   returns

     Returns a new GenomicDataset with new record groups attached.

   Definition Classes
     AvroRecordGroupGenomicDataset

8. #### abstract def replaceSequences(newSequences: SequenceDictionary): AlignmentRecordRDD

   Replaces the sequence dictionary attached to a GenomicDataset.

   Replaces the sequence dictionary attached to a GenomicDataset.

   newSequences

     The new sequence dictionary to attach.

   returns

     Returns a new GenomicDataset with the sequences replaced.

   Definition Classes
     GenomicDataset

9. #### abstract val sequences: SequenceDictionary

   The sequence dictionary describing the reference assembly this dataset is aligned to.

   The sequence dictionary describing the reference assembly this dataset is aligned to.

   Definition Classes
     GenomicDataset

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### def addProcessingStep(newProcessingStep: ProcessingStep): AlignmentRecordRDD

   Merges a new processing record with the extant computational lineage.

   Merges a new processing record with the extant computational lineage.

   returns

     Returns a new GenomicDataset with new record groups merged in.

   Definition Classes
     GenomicDatasetWithLineage

5. #### def addRecordGroup(recordGroupToAdd: RecordGroup): AlignmentRecordRDD

   Adds a single record group to the extant record groups.

   Adds a single record group to the extant record groups.

   recordGroupToAdd

     The record group to append to the extant record groups.

   returns

     Returns a new GenomicDataset with the new record group added.

   Definition Classes
     AvroRecordGroupGenomicDataset

6. #### def addRecordGroups(recordGroupsToAdd: RecordGroupDictionary): AlignmentRecordRDD

   Merges a new set of record groups with the extant record groups.

   Merges a new set of record groups with the extant record groups.

   recordGroupsToAdd

     The record group dictionary to append to the extant record groups.

   returns

     Returns a new GenomicDataset with new record groups merged in.

   Definition Classes
     AvroRecordGroupGenomicDataset

7. #### def addSequence(sequenceToAdd: SequenceRecord): AlignmentRecordRDD

   Appends metadata for a single sequence to the current RDD.

   Appends metadata for a single sequence to the current RDD.

   sequenceToAdd

     The sequence to add.

   returns

     Returns a new GenomicDataset with this sequence appended.

   Definition Classes
     GenomicDataset

8. #### def addSequences(sequencesToAdd: SequenceDictionary): AlignmentRecordRDD

   Appends sequence metadata to the current RDD.

   Appends sequence metadata to the current RDD.

   sequencesToAdd

     The new sequences to append.

   returns

     Returns a new GenomicDataset with the sequences appended.

   Definition Classes
     GenomicDataset

9. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

10. #### def binQualityScores(bins: Seq[QualityScoreBin]): AlignmentRecordRDD

    Rewrites the quality scores of reads to place all quality scores in bins.

    Rewrites the quality scores of reads to place all quality scores in bins.

    Quality score binning maps all quality scores to a limited number of discrete values, thus reducing the entropy of the quality score distribution, and reducing the amount of space that reads consume on disk.

    bins

      The bins to use.

    returns

      Reads whose quality scores are binned.

11. #### def broadcast()(implicit tTag: ClassTag[AlignmentRecord]): GenomicBroadcast[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD]

    Definition Classes
      GenomicDataset

12. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], txTag: ClassTag[(AlignmentRecord, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Y)]): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainst

13. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], txTag: ClassTag[(AlignmentRecord, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Y)]): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainst

14. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. Python/Java friendly version.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset

15. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. SparkR friendly version.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset

16. #### def broadcastRegionJoinAgainst[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(Y, AlignmentRecord)]): GenericGenomicDataset[(X, AlignmentRecord), (Y, AlignmentRecord)]

    Performs a broadcast inner join between this RDD and data that has been broadcast.

    Performs a broadcast inner join between this RDD and data that has been broadcast.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      broadcastRegionJoin

17. #### def broadcastRegionJoinAgainstAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], syuTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Y], AlignmentRecord)]): GenericGenomicDataset[(Iterable[X], AlignmentRecord), (Seq[Y], AlignmentRecord)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      broadcastRegionJoinAndGroupByRight

18. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[AlignmentRecord], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[AlignmentRecord], Y)]): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

19. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[AlignmentRecord], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[AlignmentRecord], Y)]): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

20. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. PySpark/Java friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

21. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. SparkR friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

22. #### def buildTree(rdd: RDD[(ReferenceRegion, AlignmentRecord)])(implicit tTag: ClassTag[AlignmentRecord]): IntervalArray[ReferenceRegion, AlignmentRecord]

    Attributes
      protected
    Definition Classes
      AlignmentRecordRDD → GenomicDataset

23. #### def cache(): AlignmentRecordRDD

    Caches underlying RDD in memory.

    Caches underlying RDD in memory.

    returns

      Cached GenomicDataset.

    Definition Classes
      GenomicDataset

24. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

25. #### def computeMismatchingPositions(referenceFile: ReferenceFile, overwriteExistingTags: Boolean = false, validationStringency: ValidationStringency = ValidationStringency.LENIENT): AlignmentRecordRDD

    Computes the mismatching positions field (SAM "MD" tag).

    Computes the mismatching positions field (SAM "MD" tag).

    referenceFile

      A reference file that can be broadcast to all nodes.

    overwriteExistingTags

      If true, overwrites the MD tags on reads where it is already populated. If false, we only tag reads that are currently missing an MD tag. Default is false.

    validationStringency

      If we are recalculating existing tags and we find that the MD tag that was previously on the read doesn't match our new tag, LENIENT will log a warning message, STRICT will throw an exception, and SILENT will ignore. Default is LENIENT.

    returns

      Returns a new AlignmentRecordRDD where all reads have the mismatchingPositions field populated.

26. #### def convertToSam(sortOrder: SortOrder): (RDD[SAMRecordWritable], SAMFileHeader)

27. #### def convertToSam(isSorted: Boolean = false): (RDD[SAMRecordWritable], SAMFileHeader)

    Converts an RDD of ADAM read records into SAM records.

    Converts an RDD of ADAM read records into SAM records.

    returns

      Returns a SAM/BAM formatted RDD of reads, as well as the file header.

28. #### def countKmers(kmerLength: Int): RDD[(String, Long)]

    Cuts reads into _k_-mers, and then counts the number of occurrences of each _k_-mer.

    Cuts reads into _k_-mers, and then counts the number of occurrences of each _k_-mer.

    kmerLength

      The value of _k_ to use for cutting _k_-mers.

    returns

      Returns an RDD containing k-mer/count pairs.

29. #### def countKmers(kmerLength: Integer): JavaRDD[(String, Long)]

    Cuts reads into _k_-mers, and then counts the number of occurrences of each _k_-mer.

    Cuts reads into _k_-mers, and then counts the number of occurrences of each _k_-mer.

    Java friendly variant.

    kmerLength

      The value of _k_ to use for cutting _k_-mers.

    returns

      Returns an RDD containing k-mer/count pairs.

30. #### def countKmersAsDataset(kmerLength: Integer): Dataset[(String, Long)]

    Cuts reads into _k_-mers, and then counts the number of occurrences of each _k_-mer.

    Cuts reads into _k_-mers, and then counts the number of occurrences of each _k_-mer.

    kmerLength

      The value of _k_ to use for cutting _k_-mers.

    returns

      Returns a Dataset containing k-mer/count pairs.

31. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

32. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

33. #### def filterByMapq(minimumMapq: Int): AlignmentRecordRDD

    Filter this AlignmentRecordRDD by mapping quality.

    Filter this AlignmentRecordRDD by mapping quality.

    minimumMapq

      Minimum mapping quality to filter by, inclusive.

    returns

      AlignmentRecordRDD filtered by mapping quality.

34. #### def filterByOverlappingRegion(query: ReferenceRegion): AlignmentRecordRDD

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    query

      The region to query for.

    returns

      Returns a new GenomicDataset containing only data that overlaps the query region.

    Definition Classes
      GenomicDataset

35. #### def filterByOverlappingRegions(querys: Iterable[ReferenceRegion]): AlignmentRecordRDD

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions. Java friendly version.

    querys

      The regions to query for.

    returns

      Returns a new GenomicRDD containing only data that overlaps the querys region.

    Definition Classes
      GenomicDataset

36. #### def filterByOverlappingRegions(querys: Iterable[ReferenceRegion]): AlignmentRecordRDD

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    querys

      The regions to query for.

    returns

      Returns a new GenomicDataset containing only data that overlaps the querys region.

    Definition Classes
      GenomicDataset

37. #### def filterDuplicateReads(): AlignmentRecordRDD

    Filter duplicate reads from this AlignmentRecordRDD.

    Filter duplicate reads from this AlignmentRecordRDD.

    returns

      AlignmentRecordRDD filtered to remove duplicate reads.

38. #### def filterToPrimaryAlignments(): AlignmentRecordRDD

    Filter this AlignmentRecordRDD to include only primary alignments.

    Filter this AlignmentRecordRDD to include only primary alignments.

    returns

      AlignmentRecordRDD filtered to include only primary alignments.

39. #### def filterToRecordGroup(recordGroupName: String): AlignmentRecordRDD

    Filter this AlignmentRecordRDD by record group to those that match the specified record group.

    Filter this AlignmentRecordRDD by record group to those that match the specified record group.

    recordGroupName

      Record group to filter by.

    returns

      AlignmentRecordRDD filtered by record group.

40. #### def filterToRecordGroups(recordGroupNames: Seq[String]): AlignmentRecordRDD

    Filter this AlignmentRecordRDD by record group to those that match the specified record groups.

    Filter this AlignmentRecordRDD by record group to those that match the specified record groups.

    recordGroupNames

      Sequence of record groups to filter by.

    returns

      AlignmentRecordRDD filtered by one or more record groups.

41. #### def filterToSample(recordGroupSample: String): AlignmentRecordRDD

    Filter this AlignmentRecordRDD by sample to those that match the specified sample.

    Filter this AlignmentRecordRDD by sample to those that match the specified sample.

    recordGroupSample

      Sample to filter by.

    returns

      AlignmentRecordRDD filtered by the specified sample.

42. #### def filterToSamples(recordGroupSamples: Seq[String]): AlignmentRecordRDD

    Filter this AlignmentRecordRDD by sample to those that match the specified samples.

    Filter this AlignmentRecordRDD by sample to those that match the specified samples.

    recordGroupSamples

      Sequence of samples to filter by.

    returns

      AlignmentRecordRDD filtered by the specified samples.

43. #### def filterUnalignedReads(): AlignmentRecordRDD

    Filter unaligned reads from this AlignmentRecordRDD.

    Filter unaligned reads from this AlignmentRecordRDD.

    returns

      AlignmentRecordRDD filtered to remove unaligned reads.

44. #### def filterUnpairedReads(): AlignmentRecordRDD

    Filter unpaired reads from this AlignmentRecordRDD.

    Filter unpaired reads from this AlignmentRecordRDD.

    returns

      AlignmentRecordRDD filtered to remove unpaired reads.

45. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

46. #### def flagStat(): (FlagStatMetrics, FlagStatMetrics)

    Runs a quality control pass akin to the Samtools FlagStat tool.

    Runs a quality control pass akin to the Samtools FlagStat tool.

    returns

      Returns a tuple of (failedQualityMetrics, passedQualityMetrics)

47. #### def flattenRddByRegions(): RDD[(ReferenceRegion, AlignmentRecord)]

    Attributes
      protected
    Definition Classes
      GenomicDataset

48. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otoxTag: ClassTag[(Option[AlignmentRecord], Option[X])], ouoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Option[Y])]): GenericGenomicDataset[(Option[AlignmentRecord], Option[X]), (Option[AlignmentRecord], Option[Y])]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

49. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otoxTag: ClassTag[(Option[AlignmentRecord], Option[X])], ouoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Option[Y])]): GenericGenomicDataset[(Option[AlignmentRecord], Option[X]), (Option[AlignmentRecord], Option[Y])]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

50. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[AlignmentRecord], Option[X]), (Option[AlignmentRecord], Option[Y])]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join. PySpark/Java friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

51. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[AlignmentRecord], Option[X]), (Option[AlignmentRecord], Option[Y])]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join. SparkR friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

52. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

53. #### def getReferenceRegions(elem: AlignmentRecord): Seq[ReferenceRegion]

    Returns all reference regions that overlap this read.

    Returns all reference regions that overlap this read.

    If a read is unaligned, it covers no reference region. If a read is aligned we expect it to cover a single region. A chimeric read would cover multiple regions, but we store chimeric reads in a way similar to BAM, where the split alignments are stored in multiple separate reads.

    elem

      Read to produce regions for.

    returns

      The seq of reference regions this read covers.

    Attributes
      protected
    Definition Classes
      AlignmentRecordRDD → GenomicDataset

54. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

55. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

56. #### def isSorted: Boolean

    Definition Classes
      GenomicDataset

57. #### def isTraceEnabled(): Boolean

    Attributes
      protected
    Definition Classes
      Logging

58. #### lazy val jrdd: JavaRDD[AlignmentRecord]

    The underlying RDD of genomic data, as a JavaRDD.

    The underlying RDD of genomic data, as a JavaRDD.

    Definition Classes
      GenomicDataset

59. #### def leftNormalizeIndels(): AlignmentRecordRDD

    Left normalizes the INDELs in reads containing INDELs.

    Left normalizes the INDELs in reads containing INDELs.

    returns

      Returns a new RDD where the reads that contained INDELs have their INDELs left normalized.

60. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], toxTag: ClassTag[(AlignmentRecord, Option[X])], uoyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Option[Y])]): GenericGenomicDataset[(AlignmentRecord, Option[X]), (AlignmentRecord, Option[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

61. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], toxTag: ClassTag[(AlignmentRecord, Option[X])], uoyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Option[Y])]): GenericGenomicDataset[(AlignmentRecord, Option[X]), (AlignmentRecord, Option[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

62. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(AlignmentRecord, Option[X]), (AlignmentRecord, Option[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join. PySpark/Java friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

63. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(AlignmentRecord, Option[X]), (AlignmentRecord, Option[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join. SparkR friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

64. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], toxTag: ClassTag[(AlignmentRecord, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Seq[Y])]): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with an empty Iterable in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

65. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], toxTag: ClassTag[(AlignmentRecord, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Seq[Y])]): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with an empty Iterable in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

66. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with an empty Iterable in the product of the join. PySpark/Java friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

67. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with an empty Iterable in the product of the join. SparkR friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

68. #### def log: Logger

    Attributes
      protected
    Definition Classes
      Logging

69. #### def logDebug(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

70. #### def logDebug(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

71. #### def logError(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

72. #### def logError(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

73. #### def logInfo(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

74. #### def logInfo(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

75. #### def logName: String

    Attributes
      protected
    Definition Classes
      Logging

76. #### def logTrace(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

77. #### def logTrace(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

78. #### def logWarning(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

79. #### def logWarning(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

80. #### def markDuplicates(): AlignmentRecordRDD

    Marks reads as possible fragment duplicates.

    Marks reads as possible fragment duplicates.

    returns

      A new RDD where reads have the duplicate read flag set. Duplicate reads are NOT filtered out.

81. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

82. #### final def notify(): Unit

    Definition Classes
      AnyRef

83. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

84. #### def persist(sl: StorageLevel): AlignmentRecordRDD

    Persists underlying RDD in memory or disk.

    Persists underlying RDD in memory or disk.

    sl

      new StorageLevel

    returns

      Persisted GenomicDataset.

    Definition Classes
      GenomicDataset

85. #### def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD, W]](cmd: List[String], files: List[String], environment: Map[String, String], flankSize: Integer, tFormatter: Class[W], xFormatter: OutFormatter[X], convFn: Function2[AlignmentRecordRDD, RDD[X], Z]): Z

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Java/PySpark friendly variant.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final RDD.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset

86. #### def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD, W]](cmd: Seq[Any], files: Seq[Any], environment: Map[Any, Any], flankSize: Double, tFormatter: Class[W], xFormatter: OutFormatter[X], convFn: Function2[AlignmentRecordRDD, RDD[X], Z]): Z

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    SparkR friendly variant.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final RDD.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset

87. #### def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD, W]](cmd: Seq[String], files: Seq[String] = Seq.empty, environment: Map[String, String] = Map.empty, flankSize: Int = 0, optTimeout: Option[Int] = None)(implicit tFormatterCompanion: InFormatterCompanion[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD, W], xFormatter: OutFormatter[X], convFn: (AlignmentRecordRDD, RDD[X]) ⇒ Z, tManifest: ClassTag[AlignmentRecord], xManifest: ClassTag[X]): Z

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Files are substituted in to the command with a $x syntax. E.g., to invoke a command that uses the first file from the files Seq, use $0. To access the path to the directory where the files are copied, use $root.

    Pipes require the presence of an InFormatterCompanion and an OutFormatter as implicit values. The InFormatterCompanion should be a singleton whose apply method builds an InFormatter given a specific type of GenomicDataset. The implicit InFormatterCompanion yields an InFormatter which is used to format the input to the pipe, and the implicit OutFormatter is used to parse the output from the pipe.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    optTimeout

      An optional parameter specifying how long to let a single partition run for, in seconds. If the partition times out, the partial results will be returned, and no exception will be logged. The partition will log that the command timed out.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset

88. #### val productFn: (AlignmentRecord) ⇒ AlignmentRecord

    Attributes
      protected
    Definition Classes
      AlignmentRecordRDD → GenomicDataset

89. #### def realignIndels(consensusModel: ConsensusGenerator = new ConsensusGeneratorFromReads, isSorted: Boolean = false, maxIndelSize: Int = 500, maxConsensusNumber: Int = 30, lodThreshold: Double = 5.0, maxTargetSize: Int = 3000, maxReadsPerTarget: Int = 20000, optReferenceFile: Option[ReferenceFile] = None, unclipReads: Boolean = false): AlignmentRecordRDD

    Realigns indels using a concensus-based heuristic.

    Realigns indels using a concensus-based heuristic.

    consensusModel

      The model to use for generating consensus sequences to realign against.

    isSorted

      If the input data is sorted, setting this parameter to true avoids a second sort.

    maxIndelSize

      The size of the largest indel to use for realignment.

    maxConsensusNumber

      The maximum number of consensus sequences to realign against per target region.

    lodThreshold

      Log-odds threshold to use when realigning; realignments are only finalized if the log-odds threshold is exceeded.

    maxTargetSize

      The maximum width of a single target region for realignment.

    optReferenceFile

      An optional reference. If not provided, reference will be inferred from MD tags.

    unclipReads

      If true, unclips reads prior to realignment. Else, omits clipped bases during realignment.

    returns

      Returns an RDD of mapped reads which have been realigned.

90. #### def realignIndels(consensusModel: ConsensusGenerator, isSorted: Boolean, maxIndelSize: Integer, maxConsensusNumber: Integer, lodThreshold: Double, maxTargetSize: Integer): AlignmentRecordRDD

    Realigns indels using a consensus-based heuristic.

    Realigns indels using a consensus-based heuristic.

    Java friendly variant.

    consensusModel

      The model to use for generating consensus sequences to realign against.

    isSorted

      If the input data is sorted, setting this parameter to true avoids a second sort.

    maxIndelSize

      The size of the largest indel to use for realignment.

    maxConsensusNumber

      The maximum number of consensus sequences to realign against per target region.

    lodThreshold

      Log-odds threshold to use when realigning; realignments are only finalized if the log-odds threshold is exceeded.

    maxTargetSize

      The maximum width of a single target region for realignment.

    returns

      Returns an RDD of mapped reads which have been realigned.

91. #### def reassembleReadPairs(secondPairRdd: RDD[AlignmentRecord], validationStringency: ValidationStringency = ValidationStringency.LENIENT): AlignmentRecordRDD

    Reassembles read pairs from two sets of unpaired reads.

    Reassembles read pairs from two sets of unpaired reads. The assumption is that the two sets were _originally_ paired together.

    secondPairRdd

      The rdd containing the second read from the pairs.

    validationStringency

      How stringently to validate the reads.

    returns

      Returns an RDD with the pair information recomputed.

    Note

      The RDD that this is called on should be the RDD with the first read from the pair.

92. #### def reassembleReadPairs(secondPairRdd: JavaRDD[AlignmentRecord], validationStringency: ValidationStringency): AlignmentRecordRDD

    Reassembles read pairs from two sets of unpaired reads.

    Reassembles read pairs from two sets of unpaired reads. The assumption is that the two sets were _originally_ paired together. Java friendly variant.

    secondPairRdd

      The rdd containing the second read from the pairs.

    validationStringency

      How stringently to validate the reads.

    returns

      Returns an RDD with the pair information recomputed.

    Note

      The RDD that this is called on should be the RDD with the first read from the pair.

93. #### def recalibrateBaseQualities(knownSnps: Broadcast[SnpTable], minAcceptableQuality: Int = 5, optStorageLevel: Option[StorageLevel] = Some(StorageLevel.MEMORY_ONLY), optSamplingFraction: Option[Double] = None, optSamplingSeed: Option[Long] = None): AlignmentRecordRDD

    Runs base quality score recalibration on a set of reads.

    Runs base quality score recalibration on a set of reads. Uses a table of known SNPs to mask true variation during the recalibration process.

    knownSnps

      A table of known SNPs to mask valid variants.

    minAcceptableQuality

      The minimum quality score to recalibrate.

    optStorageLevel

      An optional storage level to set for the output of the first stage of BQSR. Defaults to StorageLevel.MEMORY_ONLY.

    optSamplingFraction

      An optional fraction of reads to sample when generating the covariate table.

    optSamplingSeed

      An optional seed to provide if downsampling reads.

    returns

      Returns an RDD of recalibrated reads.

94. #### def recalibrateBaseQualities(knownSnps: VariantRDD, minAcceptableQuality: Integer, storageLevel: StorageLevel): AlignmentRecordRDD

    Runs base quality score recalibration on a set of reads.

    Runs base quality score recalibration on a set of reads. Uses a table of known SNPs to mask true variation during the recalibration process.

    Java friendly variant.

    knownSnps

      A table of known SNPs to mask valid variants.

    minAcceptableQuality

      The minimum quality score to recalibrate.

    storageLevel

      An optional storage level to set for the output of the first stage of BQSR. Set to null to omit.

    returns

      Returns an RDD of recalibrated reads.

95. #### def replaceRdd(newRdd: RDD[AlignmentRecord], newPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]] = None): AlignmentRecordRDD

    Attributes
      protected
    Definition Classes
      AlignmentRecordRDD → GenomicDataset

96. #### def replaceRddAndSequences(newRdd: RDD[AlignmentRecord], newSequences: SequenceDictionary, partitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]] = None): AlignmentRecordRDD

    Replaces the underlying RDD and SequenceDictionary and emits a new object.

    Replaces the underlying RDD and SequenceDictionary and emits a new object.

    newRdd

      New RDD to replace current RDD.

    newSequences

      New sequence dictionary to replace current dictionary.

    returns

      Returns a new AlignmentRecordRDD.

    Attributes
      protected

97. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otxTag: ClassTag[(Option[AlignmentRecord], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Y)]): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoin

98. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otxTag: ClassTag[(Option[AlignmentRecord], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Y)]): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoin

99. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join. PySpark/Java friendly version.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset

100. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

     Performs a broadcast right outer join between this RDD and another RDD.

     Performs a broadcast right outer join between this RDD and another RDD.

     In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join. SparkR friendly version.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

     Definition Classes
       GenomicDataset

101. #### def rightOuterBroadcastRegionJoinAgainst[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], oyuTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Y], AlignmentRecord)]): GenericGenomicDataset[(Option[X], AlignmentRecord), (Option[Y], AlignmentRecord)]

     Performs a broadcast right outer join between this RDD and data that has been broadcast.

     Performs a broadcast right outer join between this RDD and data that has been broadcast.

     In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset
     Note

       This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

     See also

       rightOuterBroadcastRegionJoin

102. #### def rightOuterBroadcastRegionJoinAgainstAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], syuTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Y], AlignmentRecord)]): GenericGenomicDataset[(Iterable[X], AlignmentRecord), (Seq[Y], AlignmentRecord)]

     Performs a broadcast right outer join between this RDD and another RDD.

     Performs a broadcast right outer join between this RDD and another RDD.

     In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset
     Note

       This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

     See also

       rightOuterBroadcastRegionJoinAndGroupByRight

103. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[AlignmentRecord], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[AlignmentRecord], Y)]): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

     Performs a broadcast right outer join between this RDD and another RDD.

     Performs a broadcast right outer join between this RDD and another RDD.

     In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

     genomicRdd

       The right RDD in the join.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

     Definition Classes
       GenomicDataset
     See also

       rightOuterBroadcastRegionJoinAgainstAndGroupByRight

104. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[AlignmentRecord], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[AlignmentRecord], Y)]): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

     Performs a broadcast right outer join between this RDD and another RDD.

     Performs a broadcast right outer join between this RDD and another RDD.

     In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

     Definition Classes
       GenomicDataset
     See also

       rightOuterBroadcastRegionJoinAgainstAndGroupByRight

105. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

     Performs a broadcast right outer join between this RDD and another RDD.

     Performs a broadcast right outer join between this RDD and another RDD.

     In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join. PySpark/Java friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

     Definition Classes
       GenomicDataset
     See also

       rightOuterBroadcastRegionJoinAgainstAndGroupByRight

106. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

     Performs a broadcast right outer join between this RDD and another RDD.

     Performs a broadcast right outer join between this RDD and another RDD.

     In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join. SparkR friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

     Definition Classes
       GenomicDataset
     See also

       rightOuterBroadcastRegionJoinAgainstAndGroupByRight

107. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otxTag: ClassTag[(Option[AlignmentRecord], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Y)]): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

     Performs a sort-merge right outer join between this RDD and another RDD.

     Performs a sort-merge right outer join between this RDD and another RDD.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

     genomicRdd

       The right RDD in the join.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

     Definition Classes
       GenomicDataset

108. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otxTag: ClassTag[(Option[AlignmentRecord], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Y)]): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

     Performs a sort-merge right outer join between this RDD and another RDD.

     Performs a sort-merge right outer join between this RDD and another RDD.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

     Definition Classes
       GenomicDataset

109. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

     Performs a sort-merge right outer join between this RDD and another RDD.

     Performs a sort-merge right outer join between this RDD and another RDD.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join. PySpark/Java friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

     Definition Classes
       GenomicDataset

110. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

     Performs a sort-merge right outer join between this RDD and another RDD.

     Performs a sort-merge right outer join between this RDD and another RDD.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join. SparkR friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

     Definition Classes
       GenomicDataset

111. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otixTag: ClassTag[(Option[AlignmentRecord], Iterable[X])], otsyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Seq[Y])]): GenericGenomicDataset[(Option[AlignmentRecord], Iterable[X]), (Option[AlignmentRecord], Seq[Y])]

     Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

     Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key.

     genomicRdd

       The right RDD in the join.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

     Definition Classes
       GenomicDataset

112. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otixTag: ClassTag[(Option[AlignmentRecord], Iterable[X])], ousyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Seq[Y])]): GenericGenomicDataset[(Option[AlignmentRecord], Iterable[X]), (Option[AlignmentRecord], Seq[Y])]

     Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

     Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

     Definition Classes
       GenomicDataset

113. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[AlignmentRecord], Iterable[X]), (Option[AlignmentRecord], Seq[Y])]

     Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

     Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key. PySpark/Java friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

     Definition Classes
       GenomicDataset

114. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[AlignmentRecord], Iterable[X]), (Option[AlignmentRecord], Seq[Y])]

     Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

     Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key. SparkR friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

     Definition Classes
       GenomicDataset

115. #### def save(filePath: String, isSorted: Boolean): Boolean

     Saves this RDD to disk, with the type identified by the extension.

     Saves this RDD to disk, with the type identified by the extension.

     filePath

       Path to save the file at.

     isSorted

       Whether the file is sorted or not.

     returns

       Returns true if saving succeeded.

116. #### def save(args: ADAMSaveAnyArgs, isSorted: Boolean = false): Boolean

     Saves AlignmentRecords as a directory of Parquet files or as SAM/BAM.

     Saves AlignmentRecords as a directory of Parquet files or as SAM/BAM.

     This method infers the output format from the file extension. Filenames ending in .sam/.bam are saved as SAM/BAM, and all other files are saved as Parquet.

     args

       Save configuration arguments.

     isSorted

       If the output is sorted, this will modify the SAM/BAM header.

     returns

       Returns true if saving succeeded.

117. #### def saveAsFastq(fileName: String, fileName2Opt: Option[String] = None, outputOriginalBaseQualities: Boolean = false, sort: Boolean = false, asSingleFile: Boolean = false, disableFastConcat: Boolean = false, validationStringency: ValidationStringency = ValidationStringency.LENIENT, persistLevel: Option[StorageLevel] = None): Unit

     Saves reads in FASTQ format.

     Saves reads in FASTQ format.

     fileName

       Path to save files at.

     fileName2Opt

       Optional second path for saving files. If set, two files will be saved.

     outputOriginalBaseQualities

       If true, writes out reads with the base qualities from the original qualities (SAM "OQ") field. If false, writes out reads with the base qualities from the qual field. Default is false.

     sort

       Whether to sort the FASTQ files by read name or not. Defaults to false. Sorting the output will recover pair order, if desired.

     asSingleFile

       By default (false), writes file to disk as shards with one shard per partition. If true, we save the file to disk as a single file by merging the shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     validationStringency

       Iff strict, throw an exception if any read in this RDD is not accompanied by its mate.

     persistLevel

       An optional persistance level to set. If this level is set, then reads will be cached (at the given persistance) level between passes.

118. #### def saveAsFastq(fileName: String, outputOriginalBaseQualities: Boolean, sort: Boolean, asSingleFile: Boolean, disableFastConcat: Boolean, validationStringency: ValidationStringency): Unit

     Saves reads in FASTQ format.

     Saves reads in FASTQ format.

     Java friendly variant.

     fileName

       Path to save files at.

     outputOriginalBaseQualities

       If true, writes out reads with the base qualities from the original qualities (SAM "OQ") field. If false, writes out reads with the base qualities from the qual field. Default is false.

     sort

       Whether to sort the FASTQ files by read name or not. Defaults to false. Sorting the output will recover pair order, if desired.

     asSingleFile

       If false, writes file to disk as shards with one shard per partition. If true, we save the file to disk as a single file by merging the shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     validationStringency

       Iff strict, throw an exception if any read in this RDD is not accompanied by its mate.

119. #### def saveAsPairedFastq(fileName1: String, fileName2: String, outputOriginalBaseQualities: Boolean = false, asSingleFile: Boolean = false, disableFastConcat: Boolean = false, validationStringency: ValidationStringency = ValidationStringency.LENIENT, persistLevel: Option[StorageLevel] = None): Unit

     Saves these AlignmentRecords to two FASTQ files.

     Saves these AlignmentRecords to two FASTQ files.

     The files are one for the first mate in each pair, and the other for the second mate in the pair.

     fileName1

       Path at which to save a FASTQ file containing the first mate of each pair.

     fileName2

       Path at which to save a FASTQ file containing the second mate of each pair.

     outputOriginalBaseQualities

       If true, writes out reads with the base qualities from the original qualities (SAM "OQ") field. If false, writes out reads with the base qualities from the qual field. Default is false.

     asSingleFile

       By default (false), writes file to disk as shards with one shard per partition. If true, we save the file to disk as a single file by merging the shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     validationStringency

       Iff strict, throw an exception if any read in this RDD is not accompanied by its mate.

     persistLevel

       An optional persistance level to set. If this level is set, then reads will be cached (at the given persistance) level between passes.

120. #### def saveAsPairedFastq(fileName1: String, fileName2: String, outputOriginalBaseQualities: Boolean, asSingleFile: Boolean, disableFastConcat: Boolean, validationStringency: ValidationStringency, persistLevel: StorageLevel): Unit

     Saves these AlignmentRecords to two FASTQ files.

     Saves these AlignmentRecords to two FASTQ files.

     The files are one for the first mate in each pair, and the other for the second mate in the pair. Java friendly variant.

     fileName1

       Path at which to save a FASTQ file containing the first mate of each pair.

     fileName2

       Path at which to save a FASTQ file containing the second mate of each pair.

     outputOriginalBaseQualities

       If true, writes out reads with the base qualities from the original qualities (SAM "OQ") field. If false, writes out reads with the base qualities from the qual field. Default is false.

     asSingleFile

       If false, writes file to disk as shards with one shard per partition. If true, we save the file to disk as a single file by merging the shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     validationStringency

       Iff strict, throw an exception if any read in this RDD is not accompanied by its mate.

     persistLevel

       The persistence level to cache reads at between passes.

121. #### def saveAsParquet(pathName: String): Unit

     Saves this RDD to disk as a Parquet + Avro file.

     Saves this RDD to disk as a Parquet + Avro file.

     pathName

       The path to save the file to.

     Definition Classes
       AvroGenomicDataset

122. #### def saveAsParquet(pathName: String, blockSize: Integer, pageSize: Integer, compressCodec: CompressionCodecName, disableDictionaryEncoding: Boolean): Unit

     Saves this RDD to disk as a Parquet + Avro file.

     Saves this RDD to disk as a Parquet + Avro file.

     pathName

       The path to save the file to.

     blockSize

       The size in bytes of blocks to write.

     pageSize

       The size in bytes of pages to write.

     compressCodec

       The compression codec to apply to pages.

     disableDictionaryEncoding

       If false, dictionary encoding is used. If true, delta encoding is used.

     Definition Classes
       AvroGenomicDataset

123. #### def saveAsParquet(pathName: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false): Unit

     Saves this RDD to disk as a Parquet + Avro file.

     Saves this RDD to disk as a Parquet + Avro file.

     pathName

       The path to save the file to.

     blockSize

       The size in bytes of blocks to write.

     pageSize

       The size in bytes of pages to write.

     compressCodec

       The compression codec to apply to pages.

     disableDictionaryEncoding

       If false, dictionary encoding is used. If true, delta encoding is used.

     Definition Classes
       AvroGenomicDataset → GenomicDataset

124. #### def saveAsParquet(args: SaveArgs): Unit

     Saves an RDD to Parquet.

     Saves an RDD to Parquet.

     args

       The output format configuration to use when saving the data.

     Definition Classes
       GenomicDataset

125. #### def saveAsPartitionedParquet(pathName: String, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, partitionSize: Int = 1000000): Unit

     Saves this RDD to disk in range binned partitioned Parquet format.

     Saves this RDD to disk in range binned partitioned Parquet format.

     pathName

       The path to save the partitioned Parquet file to.

     compressCodec

       Name of the compression codec to use.

     partitionSize

       Size of partitions used when writing Parquet, in base pairs (bp). Defaults to 1,000,000 bp.

     Definition Classes
       GenomicDataset

126. #### def saveAsSam(filePath: String, asType: SAMFormat, asSingleFile: Boolean, isSorted: Boolean): Unit

     Saves this RDD to disk as a SAM/BAM/CRAM file.

     Saves this RDD to disk as a SAM/BAM/CRAM file.

     filePath

       Path to save the file at.

     asType

       The SAMFormat to save as. If left null, we will infer the format from the file extension.

     asSingleFile

       If true, saves output as a single file.

     isSorted

       If the output is sorted, this will modify the header.

127. #### def saveAsSam(filePath: String, asType: Option[SAMFormat], asSingleFile: Boolean, sortOrder: SortOrder, deferMerging: Boolean, disableFastConcat: Boolean): Unit

128. #### def saveAsSam(filePath: String, asType: Option[SAMFormat] = None, asSingleFile: Boolean = false, isSorted: Boolean = false, deferMerging: Boolean = false, disableFastConcat: Boolean = false): Unit

     Saves an RDD of ADAM read data into the SAM/BAM format.

     Saves an RDD of ADAM read data into the SAM/BAM format.

     filePath

       Path to save files to.

     asType

       Selects whether to save as SAM, BAM, or CRAM. The default value is None, which means the file type is inferred from the extension.

     asSingleFile

       If true, saves output as a single file.

     isSorted

       If the output is sorted, this will modify the header.

     deferMerging

       If true and asSingleFile is true, we will save the output shards as a headerless file, but we will not merge the shards.

     disableFastConcat

       If asSingleFile is true and deferMerging is false, disables the use of the parallel file merging engine.

129. #### def saveAsSamString(): String

     Converts an RDD into the SAM spec string it represents.

     Converts an RDD into the SAM spec string it represents.

     This method converts an RDD of AlignmentRecords back to an RDD of SAMRecordWritables and a SAMFileHeader, and then maps this RDD into a string on the driver that represents this file in SAM.

     returns

       A string on the driver representing this RDD of reads in SAM format.

130. #### def saveAvro[U <: SpecificRecordBase](pathName: String, sc: SparkContext, schema: Schema, avro: Seq[U])(implicit tUag: ClassTag[U]): Unit

     Saves Avro data to a Hadoop file system.

     Saves Avro data to a Hadoop file system.

     This method uses a SparkContext to identify our underlying file system, which we then save to.

     Frustratingly enough, although all records generated by the Avro IDL compiler have a static SCHEMA$ field, this field does not belong to the SpecificRecordBase abstract class, or the SpecificRecord interface. As such, we must force the user to pass in the schema.

     U

       The type of the specific record we are saving.

     pathName

       Path to save records to.

     sc

       SparkContext used for identifying underlying file system.

     schema

       Schema of records we are saving.

     avro

       Seq of records we are saving.

     Attributes
       protected
     Definition Classes
       GenomicDataset

131. #### def saveMetadata(pathName: String): Unit

     Writes any necessary metadata to disk.

     Writes any necessary metadata to disk. If not overridden, writes the sequence dictionary to disk as Avro.

     pathName

       The path to save metadata to.

     Attributes
       protected
     Definition Classes
       AvroRecordGroupGenomicDataset → AvroGenomicDataset → GenomicDataset

132. #### def savePartitionMap(filePath: String): Unit

     Save the partition map to disk.

     Save the partition map to disk. This is done by adding the partition map to the schema.

     filePath

       The filepath where we will save the partition map.

     Attributes
       protected
     Definition Classes
       AvroGenomicDataset

133. #### def saveProcessingSteps(pathName: String): Unit

     Save the processing steps to disk.

     Save the processing steps to disk.

     pathName

       The path to save processing steps to.

     Attributes
       protected
     Definition Classes
       AvroRecordGroupGenomicDataset

134. #### def saveRddAsParquet(pathName: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false, optSchema: Option[Schema] = None): Unit

     Saves an RDD of Avro data to Parquet.

     Saves an RDD of Avro data to Parquet.

     pathName

       The path to save the file to.

     blockSize

       The size in bytes of blocks to write. Defaults to 128 * 1024 * 1024.

     pageSize

       The size in bytes of pages to write. Defaults to 1 * 1024 * 1024.

     compressCodec

       The compression codec to apply to pages. Defaults to CompressionCodecName.GZIP.

     disableDictionaryEncoding

       If false, dictionary encoding is used. If true, delta encoding is used. Defaults to false.

     optSchema

       The optional schema to set. Defaults to None.

     Attributes
       protected
     Definition Classes
       AvroGenomicDataset

135. #### def saveRddAsParquet(args: SaveArgs): Unit

     Attributes
       protected
     Definition Classes
       AvroGenomicDataset

136. #### def saveRecordGroups(pathName: String): Unit

     Save the record groups to disk.

     Save the record groups to disk.

     pathName

       The path to save record groups to.

     Attributes
       protected
     Definition Classes
       AvroRecordGroupGenomicDataset

137. #### def saveSequences(pathName: String): Unit

     Save the sequence dictionary to disk.

     Save the sequence dictionary to disk.

     pathName

       The path to save the sequence dictionary to.

     Attributes
       protected
     Definition Classes
       GenomicDataset

138. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], txTag: ClassTag[(AlignmentRecord, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Y)]): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

     Performs a sort-merge inner join between this RDD and another RDD.

     Performs a sort-merge inner join between this RDD and another RDD.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

     genomicRdd

       The right RDD in the join.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

139. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], txTag: ClassTag[(AlignmentRecord, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Y)]): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

     Performs a sort-merge inner join between this RDD and another RDD.

     Performs a sort-merge inner join between this RDD and another RDD.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

140. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

     Performs a sort-merge inner join between this RDD and another RDD.

     Performs a sort-merge inner join between this RDD and another RDD.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. PySpark/Java friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

141. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

     Performs a sort-merge inner join between this RDD and another RDD.

     Performs a sort-merge inner join between this RDD and another RDD.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. SparkR friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

142. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], tixTag: ClassTag[(AlignmentRecord, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Seq[Y])]): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. In the same operation, we group all values by the left item in the RDD.

     genomicRdd

       The right RDD in the join.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD..

     Definition Classes
       GenomicDataset

143. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], tixTag: ClassTag[(AlignmentRecord, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Seq[Y])]): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. In the same operation, we group all values by the left item in the RDD.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD..

     Definition Classes
       GenomicDataset

144. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. PySpark/Java friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD.

     Definition Classes
       GenomicDataset

145. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. SparkR friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD.

     Definition Classes
       GenomicDataset

146. #### def sort(partitions: Int = rdd.partitions.length, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[AlignmentRecord]): AlignmentRecordRDD

     Sorts our genome aligned data by reference positions, with contigs ordered by index.

     Sorts our genome aligned data by reference positions, with contigs ordered by index.

     partitions

       The number of partitions for the new RDD.

     stringency

       The level of ValidationStringency to enforce.

     returns

       Returns a new RDD containing sorted data.

     Definition Classes
       GenomicDataset
     Note

       Uses ValidationStringency to handle unaligned or where objects align to multiple positions.

     See also

       sortLexicographically

147. #### def sort(): AlignmentRecordRDD

     Sorts our genome aligned data by reference positions, with contigs ordered by index.

     Sorts our genome aligned data by reference positions, with contigs ordered by index.

     returns

       Returns a new RDD containing sorted data.

     Definition Classes
       GenomicDataset
     See also

       sortLexicographically

148. #### def sortLexicographically(partitions: Int = rdd.partitions.length, storePartitionMap: Boolean = false, storageLevel: StorageLevel = StorageLevel.MEMORY_ONLY, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[AlignmentRecord]): AlignmentRecordRDD

     Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

     Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

     partitions

       The number of partitions for the new RDD.

     storePartitionMap

       A Boolean flag to determine whether to store the partition bounds from the resulting RDD.

     storageLevel

       The level at which to persist the resulting RDD.

     stringency

       The level of ValidationStringency to enforce.

     returns

       Returns a new RDD containing sorted data.

     Definition Classes
       GenomicDataset
     Note

       Uses ValidationStringency to handle data that is unaligned or where objects align to multiple positions.

     See also

       sort

149. #### def sortLexicographically(): AlignmentRecordRDD

     Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

     Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

     returns

       Returns a new RDD containing sorted data.

     Definition Classes
       GenomicDataset
     See also

       sort

150. #### def sortReadsByReadName(): AlignmentRecordRDD

     Sorts our read data by read name.

     Sorts our read data by read name.

     returns

       Returns a new RDD containing sorted reads.

151. #### def sortReadsByReferencePosition(): AlignmentRecordRDD

     Sorts our read data by reference positions, with contigs ordered by name.

     Sorts our read data by reference positions, with contigs ordered by name.

     Sorts reads by the location where they are aligned. Unaligned reads are put at the end and sorted by read name. Contigs are ordered lexicographically.

     returns

       Returns a new RDD containing sorted reads.

     See also

       sortReadsByReferencePositionAndIndex

152. #### def sortReadsByReferencePositionAndIndex(): AlignmentRecordRDD

     Sorts our read data by reference positions, with contigs ordered by index.

     Sorts our read data by reference positions, with contigs ordered by index.

     Sorts reads by the location where they are aligned. Unaligned reads are put at the end and sorted by read name. Contigs are ordered by index that they are ordered in the SequenceDictionary.

     returns

       Returns a new RDD containing sorted reads.

     See also

       sortReadsByReferencePosition

153. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

154. #### def toCoverage(): CoverageRDD

     Converts this set of reads into a corresponding CoverageRDD.

     Converts this set of reads into a corresponding CoverageRDD.

     returns

       CoverageRDD containing mapped RDD of Coverage.

155. #### def toDF(): DataFrame

     returns

       This data as a Spark SQL DataFrame.

     Definition Classes
       GenomicDataset

156. #### def toFragments(): FragmentRDD

     Convert this set of reads into fragments.

     Convert this set of reads into fragments.

     returns

       Returns a FragmentRDD where all reads have been grouped together by the original sequence fragment they come from.

157. #### def toString(): String

     Definition Classes
       AvroRecordGroupGenomicDataset → GenomicDataset → AnyRef → Any

158. #### def transform(tFn: Function[JavaRDD[AlignmentRecord], JavaRDD[AlignmentRecord]]): AlignmentRecordRDD

     Applies a function that transforms the underlying RDD into a new RDD.

     Applies a function that transforms the underlying RDD into a new RDD.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

159. #### def transform(tFn: (RDD[AlignmentRecord]) ⇒ RDD[AlignmentRecord]): AlignmentRecordRDD

     Applies a function that transforms the underlying RDD into a new RDD.

     Applies a function that transforms the underlying RDD into a new RDD.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

160. #### def transformDataFrame(tFn: Function[DataFrame, DataFrame]): AlignmentRecordRDD

     Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API. Java-friendly variant.

     tFn

       A function that transforms the underlying RDD as a DataFrame.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

161. #### def transformDataFrame(tFn: (DataFrame) ⇒ DataFrame)(implicit uTag: scala.reflect.api.JavaUniverse.TypeTag[AlignmentRecord]): AlignmentRecordRDD

     Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     tFn

       A function that transforms the underlying RDD as a DataFrame.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

162. #### def transformDataset(tFn: (Dataset[AlignmentRecord]) ⇒ Dataset[AlignmentRecord]): AlignmentRecordRDD

     Applies a function that transforms the underlying RDD into a new RDD using the Spark SQL API.

     Applies a function that transforms the underlying RDD into a new RDD using the Spark SQL API.

     tFn

       A function that transforms the underlying RDD as a Dataset.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       AlignmentRecordRDD → GenomicDataset

163. #### def transmute[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[JavaRDD[AlignmentRecord], JavaRDD[X]], convFn: Function2[AlignmentRecordRDD, RDD[X], Z]): Z

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly version.

     tFn

       A function that transforms the underlying RDD.

     convFn

       The conversion function used to build the final RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

164. #### def transmute[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (RDD[AlignmentRecord]) ⇒ RDD[X])(implicit convFn: (AlignmentRecordRDD, RDD[X]) ⇒ Z): Z

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

165. #### def transmuteDataFrame[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[DataFrame, DataFrame], convFn: GenomicDatasetConversion[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD, X, Y, Z]): Z

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly variant.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

166. #### def transmuteDataFrame[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (DataFrame) ⇒ DataFrame)(implicit yTag: scala.reflect.api.JavaUniverse.TypeTag[Y], convFn: (AlignmentRecordRDD, Dataset[Y]) ⇒ Z): Z

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly variant.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

167. #### def transmuteDataset[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[Dataset[AlignmentRecord], Dataset[Y]], convFn: GenomicDatasetConversion[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD, X, Y, Z]): Z

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly variant.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

168. #### def transmuteDataset[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (Dataset[AlignmentRecord]) ⇒ Dataset[Y])(implicit yTag: scala.reflect.api.JavaUniverse.TypeTag[Y], convFn: (AlignmentRecordRDD, Dataset[Y]) ⇒ Z): Z

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

169. #### val uTag: scala.reflect.api.JavaUniverse.TypeTag[AlignmentRecord]

     Definition Classes
       AlignmentRecordRDD → GenomicDataset

170. #### def union(rdds: AlignmentRecordRDD*): AlignmentRecordRDD

     Unions together multiple genomic RDDs.

     Unions together multiple genomic RDDs.

     rdds

       RDDs to union with this RDD.

     Definition Classes
       AlignmentRecordRDD → GenomicDataset

171. #### def union(rdds: List[AlignmentRecordRDD]): AlignmentRecordRDD

     Unions together multiple genomic RDDs.

     Unions together multiple genomic RDDs.

     rdds

       RDDs to union with this RDD.

     Definition Classes
       GenomicDataset

172. #### def unpersist(): AlignmentRecordRDD

     Unpersists underlying RDD from memory or disk.

     Unpersists underlying RDD from memory or disk.

     returns

       Uncached GenomicDataset.

     Definition Classes
       GenomicDataset

173. #### val unproductFn: (AlignmentRecord) ⇒ AlignmentRecord

     Attributes
       protected
     Definition Classes
       AlignmentRecordRDD → GenomicDataset

174. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

175. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

176. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

177. #### def writeTextRdd[T](rdd: RDD[T], outputPath: String, asSingleFile: Boolean, disableFastConcat: Boolean, optHeaderPath: Option[String] = None): Unit

     Writes an RDD to disk as text and optionally merges.

     Writes an RDD to disk as text and optionally merges.

     rdd

       RDD to save.

     outputPath

       Output path to save text files to.

     asSingleFile

       If true, combines all partition shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     optHeaderPath

       If provided, the header file to include.

     Attributes
       protected
     Definition Classes
       GenomicDataset

### Inherited from AvroRecordGroupGenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD]

### Inherited from GenomicDatasetWithLineage[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD]

### Inherited from AvroGenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD]

### Inherited from GenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordRDD]

### Inherited from Logging

### Inherited from AnyRef

### Inherited from Any

### Ungrouped